using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Microsoft.Web.Services3.Security;
using Microsoft.Web.Services3.Security.Tokens;
using System.Web.Security;

namespace CSharpFoliotekWebPortal
{
	/// <summary>
	/// Summary description for WebPortal.
	/// </summary>
	public partial class Default : System.Web.UI.Page
	{
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			if(!Page.IsPostBack) // on first load, show the portal
			{
				divPortalPage.Visible=true;
				divAccountLinkPage.Visible=false;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		FoliotekLoginWebService.LoginWse loginProxy;
		/// <summary>
		/// Gets the reference used to access webservice login functions
		/// </summary>
		/// <returns>a set up webservice reference</returns>
		private FoliotekLoginWebService.LoginWse GetWebServiceProxy()
		{
			if(loginProxy==null)// reuse if connection already made this roundtrip
			{
				// Create the username token (developer webservice login)
				// if you do not already have a developer login, please contact
				// Foliotek to receive one
				loginProxy = new FoliotekLoginWebService.LoginWse();

                loginProxy.SetPolicy("Login");
			}
			return loginProxy;
		}

		protected void lnkFoliotek_Click(object sender, System.EventArgs e)
		{
			// try to get a ticket for access
			// User.Identity.Name is the name for the user when using dotnet
			// forms authentication, needs to be replaced with however you are storing the username.
			// also note that the web.config is set up so that a user must be logged in to access this page
			string ticket=GetWebServiceProxy().GetAccessTicket(User.Identity.Name);

			if(ticket.ToLower().StartsWith("failed")) // returns failed if user hasn't previously been linked, go to link account step
			{
				divPortalPage.Visible=false;
				divAccountLinkPage.Visible=true;
			}
			else
			{
				//  new functionality can be tested on http://dev.foliotek.com
				//  make sure that all production code uses https://secure.foliotek.com
				Response.Redirect("https://secure.foliotek.com/?ticket="+ticket);  // redirect to foliotek auto login w/ the given ticket
			}
		}

		protected void btnLink_Click(object sender, System.EventArgs e)
		{
			// try to link the account
			string response = GetWebServiceProxy().LinkAccount(txtFoliotekUserName.Text,txtFoliotekUserPass.Text,User.Identity.Name);

			if(response.ToLower().StartsWith("failed")) // returns failed if the account/pw isn't valid
			{
				lblMsg.Text="Foliotek account linking "+response;
			}
			else
			{
				// linked successfully, go ahead and get a ticket and redirect to foliotek auto login
				Response.Redirect("https://secure.foliotek.com/?ticket="+GetWebServiceProxy().GetAccessTicket(User.Identity.Name));
			}
		}

		protected void lnkSignOut_Click(object sender, System.EventArgs e)
		{
			FormsAuthentication.SignOut();
			Response.Redirect("Logon.aspx?ReturnUrl="+Server.UrlEncode(Request.RawUrl));
		}
	}
}
